/** @file atem_ggo.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef ATEM_GGO_H
#define ATEM_GGO_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE PACKAGE
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#ifdef PACKAGE_NAME
#define CMDLINE_PARSER_PACKAGE_NAME PACKAGE_NAME
#else
#define CMDLINE_PARSER_PACKAGE_NAME PACKAGE
#endif
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  char * output_arg;	/**< @brief Write output to FILE instead of stdout..  */
  char * output_orig;	/**< @brief Write output to FILE instead of stdout. original value given at command line.  */
  const char *output_help; /**< @brief Write output to FILE instead of stdout. help description.  */
  const char *symbols_help; /**< @brief Dump symbol info instead of time series data. help description.  */
  const char *skip_header_help; /**< @brief Don't print header row. help description.  */
  char * field_separator_arg;	/**< @brief Field separator, default: TAB (ASCII)..  */
  char * field_separator_orig;	/**< @brief Field separator, default: TAB (ASCII). original value given at command line.  */
  const char *field_separator_help; /**< @brief Field separator, default: TAB (ASCII). help description.  */
  char * format_arg;	/**< @brief Set the list of output columns, see COLUMNS and BITSET format below..  */
  char * format_orig;	/**< @brief Set the list of output columns, see COLUMNS and BITSET format below. original value given at command line.  */
  const char *format_help; /**< @brief Set the list of output columns, see COLUMNS and BITSET format below. help description.  */
  const char *float_openint_help; /**< @brief Print openint column as float. help description.  */
  const char *float_volume_help; /**< @brief Print volume column as float. help description.  */
  char * date_from_arg;	/**< @brief Print data from specified date on (YYYY-MM-DD)..  */
  char * date_from_orig;	/**< @brief Print data from specified date on (YYYY-MM-DD). original value given at command line.  */
  const char *date_from_help; /**< @brief Print data from specified date on (YYYY-MM-DD). help description.  */
  char * exclude_older_than_arg;	/**< @brief Don't process data files older than date time (YYYY-MM-DD hh:mm:ss). A leading '-' reverts the statement..  */
  char * exclude_older_than_orig;	/**< @brief Don't process data files older than date time (YYYY-MM-DD hh:mm:ss). A leading '-' reverts the statement. original value given at command line.  */
  const char *exclude_older_than_help; /**< @brief Don't process data files older than date time (YYYY-MM-DD hh:mm:ss). A leading '-' reverts the statement. help description.  */
  int fdat_arg;	/**< @brief Process specified dat file number only..  */
  char * fdat_orig;	/**< @brief Process specified dat file number only. original value given at command line.  */
  const char *fdat_help; /**< @brief Process specified dat file number only. help description.  */
  const char *ignore_master_help; /**< @brief Ignore MASTER file. help description.  */
  const char *ignore_emaster_help; /**< @brief Ignore EMASTER file. help description.  */
  const char *ignore_xmaster_help; /**< @brief Ignore XMASTER file. help description.  */
  const char *dump_master_help; /**< @brief Dump MASTER file. help description.  */
  const char *dump_emaster_help; /**< @brief Dump EMASTER file. help description.  */
  const char *dump_xmaster_help; /**< @brief Dump XMASTER file. help description.  */
  const char *help_help; /**< @brief Show this help message. help description.  */
  const char *full_help_help; /**< @brief Print help, including hidden debugging options. help description.  */
  const char *version_help; /**< @brief Print version string and exit. help description.  */
  const char *usage_help; /**< @brief Display brief usage message. help description.  */
  
  unsigned int output_given ;	/**< @brief Whether output was given.  */
  unsigned int symbols_given ;	/**< @brief Whether symbols was given.  */
  unsigned int skip_header_given ;	/**< @brief Whether skip-header was given.  */
  unsigned int field_separator_given ;	/**< @brief Whether field-separator was given.  */
  unsigned int format_given ;	/**< @brief Whether format was given.  */
  unsigned int float_openint_given ;	/**< @brief Whether float-openint was given.  */
  unsigned int float_volume_given ;	/**< @brief Whether float-volume was given.  */
  unsigned int date_from_given ;	/**< @brief Whether date-from was given.  */
  unsigned int exclude_older_than_given ;	/**< @brief Whether exclude-older-than was given.  */
  unsigned int fdat_given ;	/**< @brief Whether fdat was given.  */
  unsigned int ignore_master_given ;	/**< @brief Whether ignore-master was given.  */
  unsigned int ignore_emaster_given ;	/**< @brief Whether ignore-emaster was given.  */
  unsigned int ignore_xmaster_given ;	/**< @brief Whether ignore-xmaster was given.  */
  unsigned int dump_master_given ;	/**< @brief Whether dump-master was given.  */
  unsigned int dump_emaster_given ;	/**< @brief Whether dump-emaster was given.  */
  unsigned int dump_xmaster_given ;	/**< @brief Whether dump-xmaster was given.  */
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int full_help_given ;	/**< @brief Whether full-help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int usage_given ;	/**< @brief Whether usage was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];
/** @brief all the lines making the full help output (including hidden options) */
extern const char *gengetopt_args_info_full_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the full help (including hidden options)
 */
void cmdline_parser_print_full_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* ATEM_GGO_H */
